#include <windows.h>
#include <shlwapi.h>
#define EZXML_NOMMAP		/// ignore cygwin's sys/mman.h (used by ezXML)
#include "ezxml/ezxml.c"	/// include ezXML source

#define DLL_EXPORT __declspec(dllexport)

/// Manufacturer structure
typedef struct MfcStru{
	DWORD	mfc_id;					/// ID of the Manufacturer
	DWORD	mfc_logo;				/// Manufacturer logo ID. Logos are hardcoded as resources in the DLL
	char	mfc_name_short[0x14];	/// Short manufacturer name (eg. "ATMEL", "ALI", etc.)
	char	mfc_name_full[0x28];	/// Full manufacturer name (eg. "Atmel Corporation", "Acer Laboratories Inc", etc.)
	byte*	mfc_ic_struc;			/// Pointer to the ICs structure buffer
	DWORD	mfc_ic_count;			/// Number of ICs for this manufacturer
} MfcStru;


/// IC strcture
typedef struct ICStru{
	DWORD	_IC_u01;			/// 0x00
	DWORD	_IC_u02;			/// 0x04 Not used, always 0x00000000
	DWORD	_IC_Type;			/// 0x08 Chip type: 0=""; 1="EEPROM"; 2="MCU/MPU"; 3="PLD/CPLD"; 4="SRAM"; 5="LOGIC"
	char	_IC_Name[0x28];		/// 0x0C Chip name
	DWORD	_IC_u03;			/// 0x34
	DWORD	_IC_CodeMemory;		/// 0x38 size of Code memory
	DWORD	_IC_DataMemory;		/// 0x3C size of Data memory
	DWORD	_IC_UserMemory;		/// 0x40 size of User memory ("User.Row" or "Encry.TB")
	WORD	_IC_u04;			/// 0x44
	WORD	_IC_u05;			/// 0x46
	WORD	_IC_u06;			/// 0x48
	byte	_IC_u07;			/// 0x4A
	byte	_IC_u08;			/// 0x4B
	DWORD	_IC_u09;			/// 0x4C
	DWORD	_IC_u10;			/// 0x50
	DWORD	_IC_ChipID;			/// 0x54 Chip ID
	DWORD	_IC_u11;			/// 0x58 Not used, always 0x00000000
	DWORD	_IC_u12;			/// 0x5C
	DWORD	_IC_u13;			/// 0x60
	DWORD	_IC_Package;		/// 0x64 IC package
	DWORD	_IC_u14;			/// 0x68
} ICStru;

char szChipDB[] = "InfoIC.xml";
DWORD countMFC;
DWORD countIC;
byte *dataMFC, *dataMFC_t;
byte *dataIC, *dataIC_t;
MfcStru suMfc;
ICStru suIC;

/// Export functions declaration
BOOL DLL_EXPORT GetIcStru(DWORD, DWORD, byte*);
DWORD DLL_EXPORT GetIcMFC(char*, byte*, DWORD);
DWORD DLL_EXPORT GetIcList(char*, byte*, DWORD, DWORD);
DWORD DLL_EXPORT GetMfcStru(DWORD, byte*);
DWORD DLL_EXPORT GetDllInfo(DWORD*, DWORD*);
